[arch-commits] Commit in gcc/repos (10 files)

Giancarlo Razzolini grazzolini at archlinux.org
Thu May 13 16:11:30 UTC 2021


    Date: Thursday, May 13, 2021 @ 16:11:29
  Author: grazzolini
Revision: 415311

archrelease: copy trunk to staging-x86_64

Added:
  gcc/repos/staging-x86_64/
  gcc/repos/staging-x86_64/PKGBUILD
    (from rev 415304, gcc/trunk/PKGBUILD)
  gcc/repos/staging-x86_64/c89
    (from rev 415305, gcc/trunk/c89)
  gcc/repos/staging-x86_64/c99
    (from rev 415305, gcc/trunk/c99)
  gcc/repos/staging-x86_64/fs64270.patch
    (from rev 415306, gcc/trunk/fs64270.patch)
  gcc/repos/staging-x86_64/gcc-ada-repro.patch
    (from rev 415306, gcc/trunk/gcc-ada-repro.patch)
  gcc/repos/staging-x86_64/gcc11-Wno-format-security.patch
    (from rev 415307, gcc/trunk/gcc11-Wno-format-security.patch)
  gcc/repos/staging-x86_64/gdc_phobos_path.patch
    (from rev 415307, gcc/trunk/gdc_phobos_path.patch)
  gcc/repos/staging-x86_64/ipa-fix-ICE-in-get_default_value.patch
    (from rev 415307, gcc/trunk/ipa-fix-ICE-in-get_default_value.patch)
  gcc/repos/staging-x86_64/ipa-fix-bit-CPP-when-combined-with-IPA-bit-CP.patch
    (from rev 415308, gcc/trunk/ipa-fix-bit-CPP-when-combined-with-IPA-bit-CP.patch)

-----------------------------------------------------+
 PKGBUILD                                            |  428 ++++++++++++++++++
 c89                                                 |   10 
 c99                                                 |   10 
 fs64270.patch                                       |   26 +
 gcc-ada-repro.patch                                 |   15 
 gcc11-Wno-format-security.patch                     |   27 +
 gdc_phobos_path.patch                               |   14 
 ipa-fix-ICE-in-get_default_value.patch              |   80 +++
 ipa-fix-bit-CPP-when-combined-with-IPA-bit-CP.patch |  147 ++++++
 9 files changed, 757 insertions(+)

Copied: gcc/repos/staging-x86_64/PKGBUILD (from rev 415304, gcc/trunk/PKGBUILD)
===================================================================
--- staging-x86_64/PKGBUILD	                        (rev 0)
+++ staging-x86_64/PKGBUILD	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,428 @@
+# Maintainer:  Bartłomiej Piotrowski <bpiotrowski at archlinux.org>
+# Contributor: Allan McRae <allan at archlinux.org>
+# Contributor: Daniel Kozak <kozzi11 at gmail.com>
+
+# toolchain build order: linux-api-headers->glibc->binutils->gcc->binutils->glibc
+# NOTE: libtool requires rebuilt with each new gcc version
+
+pkgname=(gcc gcc-libs gcc-fortran gcc-objc gcc-ada gcc-go lib32-gcc-libs gcc-d)
+pkgver=11.1.0
+_majorver=${pkgver%%.*}
+_islver=0.24
+pkgrel=1
+pkgdesc='The GNU Compiler Collection'
+arch=(x86_64)
+license=(GPL LGPL FDL custom)
+url='https://gcc.gnu.org'
+makedepends=(binutils libmpc gcc-ada doxygen lib32-glibc lib32-gcc-libs python git libxcrypt)
+checkdepends=(dejagnu inetutils)
+options=(!emptydirs)
+_libdir=usr/lib/gcc/$CHOST/${pkgver%%+*}
+# _commit=6beb39ee6c465c21d0cc547fd66b445100cdcc35
+# source=(git://gcc.gnu.org/git/gcc.git#commit=$_commit
+source=(https://sourceware.org/pub/gcc/releases/gcc-${pkgver}/gcc-${pkgver}.tar.xz{,.sig}
+        http://isl.gforge.inria.fr/isl-${_islver}.tar.xz
+        c89 c99
+        gdc_phobos_path.patch
+        fs64270.patch
+        ipa-fix-bit-CPP-when-combined-with-IPA-bit-CP.patch
+        ipa-fix-ICE-in-get_default_value.patch
+        gcc-ada-repro.patch
+        gcc11-Wno-format-security.patch
+)
+validpgpkeys=(F3691687D867B81B51CE07D9BBE43771487328A9  # bpiotrowski at archlinux.org
+              86CFFCA918CF3AF47147588051E8B148A9999C34  # evangelos at foutrelis.com
+              13975A70E63C361C73AE69EF6EEB81F8981C74C7  # richard.guenther at gmail.com
+              D3A93CAD751C2AF4F8C7AD516C35B99309B5FA62) # Jakub Jelinek <jakub at redhat.com>
+sha256sums=('4c4a6fb8a8396059241c2e674b85b351c26a5d678274007f076957afa1cc9ddf'
+            'SKIP'
+            '043105cc544f416b48736fff8caf077fb0663a717d06b1113f16e391ac99ebad'
+            'de48736f6e4153f03d0a5d38ceb6c6fdb7f054e8f47ddd6af0a3dbf14f27b931'
+            '2513c6d9984dd0a2058557bf00f06d8d5181734e41dcfe07be7ed86f2959622a'
+            'c86372c207d174c0918d4aedf1cb79f7fc093649eb1ad8d9450dccc46849d308'
+            '1ef190ed4562c4db8c1196952616cd201cfdd788b65f302ac2cc4dabb4d72cee'
+            'fcb11c9bcea320afd202b031b48f8750aeaedaa4b0c5dddcd2c0a16381e927e4'
+            '42865f2af3f48140580c4ae70b6ea03b5bdca0f29654773ef0d42ce00d60ea16'
+            '1773f5137f08ac1f48f0f7297e324d5d868d55201c03068670ee4602babdef2f'
+            '504e4b5a08eb25b6c35f19fdbe0c743ae4e9015d0af4759e74150006c283585e')
+
+prepare() {
+  [[ ! -d gcc ]] && ln -s gcc-${pkgver/+/-} gcc
+  cd gcc
+
+  # link isl for in-tree build
+  ln -s ../isl-${_islver} isl
+
+  # Do not run fixincludes
+  sed -i 's@\./fixinc\.sh at -c true@' gcc/Makefile.in
+
+  # Arch Linux installs x86_64 libraries /lib
+  sed -i '/m64=/s/lib64/lib/' gcc/config/i386/t-linux64
+
+  # hack! - some configure tests for header files using "$CPP $CPPFLAGS"
+  sed -i "/ac_cpp=/s/\$CPPFLAGS/\$CPPFLAGS -O2/" {libiberty,gcc}/configure
+
+  # D hacks
+  patch -p1 -i "$srcdir/gdc_phobos_path.patch"
+
+  # Reproducible gcc-ada
+  patch -Np0 < "$srcdir/gcc-ada-repro.patch"
+
+  # configure.ac: When adding -Wno-format, also add -Wno-format-security
+  patch -Np0 < "$srcdir/gcc11-Wno-format-security.patch"
+
+  mkdir -p "$srcdir/gcc-build"
+}
+
+build() {
+  cd gcc-build
+
+  # using -pipe causes spurious test-suite failures
+  # http://gcc.gnu.org/bugzilla/show_bug.cgi?id=48565
+  CFLAGS=${CFLAGS/-pipe/}
+  CXXFLAGS=${CXXFLAGS/-pipe/}
+
+  "$srcdir/gcc/configure" --prefix=/usr \
+      --libdir=/usr/lib \
+      --libexecdir=/usr/lib \
+      --mandir=/usr/share/man \
+      --infodir=/usr/share/info \
+      --with-bugurl=https://bugs.archlinux.org/ \
+      --enable-languages=c,c++,ada,fortran,go,lto,objc,obj-c++,d \
+      --with-isl \
+      --with-linker-hash-style=gnu \
+      --with-system-zlib \
+      --enable-__cxa_atexit \
+      --enable-cet=auto \
+      --enable-checking=release \
+      --enable-clocale=gnu \
+      --enable-default-pie \
+      --enable-default-ssp \
+      --enable-gnu-indirect-function \
+      --enable-gnu-unique-object \
+      --enable-install-libiberty \
+      --enable-linker-build-id \
+      --enable-lto \
+      --enable-multilib \
+      --enable-plugin \
+      --enable-shared \
+      --enable-threads=posix \
+      --disable-libssp \
+      --disable-libstdcxx-pch \
+      --disable-libunwind-exceptions \
+      --disable-werror \
+      gdc_include_dir=/usr/include/dlang/gdc
+
+  make
+
+  # make documentation
+  make -C $CHOST/libstdc++-v3/doc doc-man-doxygen
+}
+
+check() {
+  cd gcc-build
+
+  # disable libphobos test to avoid segfaults and other unfunny ways to waste my time  
+  sed -i '/maybe-check-target-libphobos \\/d' Makefile 
+
+  # do not abort on error as some are "expected"
+  make -k check || true
+  "$srcdir/gcc/contrib/test_summary"
+}
+
+package_gcc-libs() {
+  pkgdesc='Runtime libraries shipped by GCC'
+  depends=('glibc>=2.27')
+  options+=(!strip)
+  provides=($pkgname-multilib libgo.so libgfortran.so libgphobos.so
+            libubsan.so libasan.so libtsan.so liblsan.so)
+  replaces=($pkgname-multilib libgphobos)
+
+  cd gcc-build
+  make -C $CHOST/libgcc DESTDIR="$pkgdir" install-shared
+  rm -f "$pkgdir/$_libdir/libgcc_eh.a"
+
+  for lib in libatomic \
+             libgfortran \
+             libgo \
+             libgomp \
+             libitm \
+             libquadmath \
+             libsanitizer/{a,l,ub,t}san \
+             libstdc++-v3/src \
+             libvtv; do
+    make -C $CHOST/$lib DESTDIR="$pkgdir" install-toolexeclibLTLIBRARIES
+  done
+
+  make -C $CHOST/libobjc DESTDIR="$pkgdir" install-libs
+  make -C $CHOST/libstdc++-v3/po DESTDIR="$pkgdir" install
+
+  make -C $CHOST/libphobos DESTDIR="$pkgdir" install
+  rm -rf "$pkgdir"/$_libdir/include/d/
+  rm -f "$pkgdir"/usr/lib/libgphobos.spec
+
+  for lib in libgomp \
+             libitm \
+             libquadmath; do
+    make -C $CHOST/$lib DESTDIR="$pkgdir" install-info
+  done
+
+  # remove files provided by lib32-gcc-libs
+  rm -rf "$pkgdir"/usr/lib32/
+
+  # Install Runtime Library Exception
+  install -Dm644 "$srcdir/gcc/COPYING.RUNTIME" \
+    "$pkgdir/usr/share/licenses/gcc-libs/RUNTIME.LIBRARY.EXCEPTION"
+}
+
+package_gcc() {
+  pkgdesc="The GNU Compiler Collection - C and C++ frontends"
+  depends=("gcc-libs=$pkgver-$pkgrel" 'binutils>=2.28' libmpc)
+  groups=('base-devel')
+  optdepends=('lib32-gcc-libs: for generating code for 32-bit ABI')
+  provides=($pkgname-multilib)
+  replaces=($pkgname-multilib)
+  options+=(staticlibs)
+
+  cd gcc-build
+
+  make -C gcc DESTDIR="$pkgdir" install-driver install-cpp install-gcc-ar \
+    c++.install-common install-headers install-plugin install-lto-wrapper
+
+  install -m755 -t "$pkgdir/usr/bin/" gcc/gcov{,-tool}
+  install -m755 -t "$pkgdir/${_libdir}/" gcc/{cc1,cc1plus,collect2,lto1}
+
+  make -C $CHOST/libgcc DESTDIR="$pkgdir" install
+  make -C $CHOST/32/libgcc DESTDIR="$pkgdir" install
+  rm -f "$pkgdir"/usr/lib{,32}/libgcc_s.so*
+
+  make -C $CHOST/libstdc++-v3/src DESTDIR="$pkgdir" install
+  make -C $CHOST/libstdc++-v3/include DESTDIR="$pkgdir" install
+  make -C $CHOST/libstdc++-v3/libsupc++ DESTDIR="$pkgdir" install
+  make -C $CHOST/libstdc++-v3/python DESTDIR="$pkgdir" install
+  make -C $CHOST/32/libstdc++-v3/src DESTDIR="$pkgdir" install
+  make -C $CHOST/32/libstdc++-v3/include DESTDIR="$pkgdir" install
+  make -C $CHOST/32/libstdc++-v3/libsupc++ DESTDIR="$pkgdir" install
+
+  make DESTDIR="$pkgdir" install-libcc1
+  install -d "$pkgdir/usr/share/gdb/auto-load/usr/lib"
+  mv "$pkgdir"/usr/lib/libstdc++.so.6.*-gdb.py \
+    "$pkgdir/usr/share/gdb/auto-load/usr/lib/"
+  rm "$pkgdir"/usr/lib{,32}/libstdc++.so*
+
+  make DESTDIR="$pkgdir" install-fixincludes
+  make -C gcc DESTDIR="$pkgdir" install-mkheaders
+
+  make -C lto-plugin DESTDIR="$pkgdir" install
+  install -dm755 "$pkgdir"/usr/lib/bfd-plugins/
+  ln -s /${_libdir}/liblto_plugin.so \
+    "$pkgdir/usr/lib/bfd-plugins/"
+
+  make -C $CHOST/libgomp DESTDIR="$pkgdir" install-nodist_{libsubinclude,toolexeclib}HEADERS
+  make -C $CHOST/libitm DESTDIR="$pkgdir" install-nodist_toolexeclibHEADERS
+  make -C $CHOST/libquadmath DESTDIR="$pkgdir" install-nodist_libsubincludeHEADERS
+  make -C $CHOST/libsanitizer DESTDIR="$pkgdir" install-nodist_{saninclude,toolexeclib}HEADERS
+  make -C $CHOST/libsanitizer/asan DESTDIR="$pkgdir" install-nodist_toolexeclibHEADERS
+  make -C $CHOST/libsanitizer/tsan DESTDIR="$pkgdir" install-nodist_toolexeclibHEADERS
+  make -C $CHOST/libsanitizer/lsan DESTDIR="$pkgdir" install-nodist_toolexeclibHEADERS
+  make -C $CHOST/32/libgomp DESTDIR="$pkgdir" install-nodist_toolexeclibHEADERS
+  make -C $CHOST/32/libitm DESTDIR="$pkgdir" install-nodist_toolexeclibHEADERS
+  make -C $CHOST/32/libsanitizer DESTDIR="$pkgdir" install-nodist_{saninclude,toolexeclib}HEADERS
+  make -C $CHOST/32/libsanitizer/asan DESTDIR="$pkgdir" install-nodist_toolexeclibHEADERS
+
+  make -C libiberty DESTDIR="$pkgdir" install
+  install -m644 libiberty/pic/libiberty.a "$pkgdir/usr/lib"
+
+  make -C gcc DESTDIR="$pkgdir" install-man install-info
+  rm "$pkgdir"/usr/share/man/man1/{gccgo,gfortran,gdc}.1
+  rm "$pkgdir"/usr/share/info/{gccgo,gfortran,gnat-style,gnat_rm,gnat_ugn,gdc}.info
+
+  make -C libcpp DESTDIR="$pkgdir" install
+  make -C gcc DESTDIR="$pkgdir" install-po
+
+  # many packages expect this symlink
+  ln -s gcc "$pkgdir"/usr/bin/cc
+
+  # POSIX conformance launcher scripts for c89 and c99
+  install -Dm755 "$srcdir/c89" "$pkgdir/usr/bin/c89"
+  install -Dm755 "$srcdir/c99" "$pkgdir/usr/bin/c99"
+
+  # install the libstdc++ man pages
+  make -C $CHOST/libstdc++-v3/doc DESTDIR="$pkgdir" doc-install-man
+
+  # remove files provided by lib32-gcc-libs
+  rm -f "$pkgdir"/usr/lib32/lib{stdc++,gcc_s}.so
+
+  # byte-compile python libraries
+  python -m compileall "$pkgdir/usr/share/gcc-${pkgver%%+*}/"
+  python -O -m compileall "$pkgdir/usr/share/gcc-${pkgver%%+*}/"
+
+  # Install Runtime Library Exception
+  install -d "$pkgdir/usr/share/licenses/$pkgname/"
+  ln -s /usr/share/licenses/gcc-libs/RUNTIME.LIBRARY.EXCEPTION \
+    "$pkgdir/usr/share/licenses/$pkgname/"
+}
+
+package_gcc-fortran() {
+  pkgdesc='Fortran front-end for GCC'
+  depends=("gcc=$pkgver-$pkgrel")
+  provides=($pkgname-multilib)
+  replaces=($pkgname-multilib)
+
+  cd gcc-build
+  make -C $CHOST/libgfortran DESTDIR="$pkgdir" install-cafexeclibLTLIBRARIES \
+    install-{toolexeclibDATA,nodist_fincludeHEADERS,gfor_cHEADERS}
+  make -C $CHOST/32/libgfortran DESTDIR="$pkgdir" install-cafexeclibLTLIBRARIES \
+    install-{toolexeclibDATA,nodist_fincludeHEADERS,gfor_cHEADERS}
+  make -C $CHOST/libgomp DESTDIR="$pkgdir" install-nodist_fincludeHEADERS
+  make -C gcc DESTDIR="$pkgdir" fortran.install-{common,man,info}
+  install -Dm755 gcc/f951 "$pkgdir/${_libdir}/f951"
+
+  ln -s gfortran "$pkgdir/usr/bin/f95"
+
+  # Install Runtime Library Exception
+  install -d "$pkgdir/usr/share/licenses/$pkgname/"
+  ln -s /usr/share/licenses/gcc-libs/RUNTIME.LIBRARY.EXCEPTION \
+    "$pkgdir/usr/share/licenses/$pkgname/"
+}
+
+package_gcc-objc() {
+  pkgdesc='Objective-C front-end for GCC'
+  depends=("gcc=$pkgver-$pkgrel")
+  provides=($pkgname-multilib)
+  replaces=($pkgname-multilib)
+
+  cd gcc-build
+  make DESTDIR="$pkgdir" -C $CHOST/libobjc install-headers
+  install -dm755 "$pkgdir/${_libdir}"
+  install -m755 gcc/cc1obj{,plus} "$pkgdir/${_libdir}/"
+
+  # Install Runtime Library Exception
+  install -d "$pkgdir/usr/share/licenses/$pkgname/"
+  ln -s /usr/share/licenses/gcc-libs/RUNTIME.LIBRARY.EXCEPTION \
+    "$pkgdir/usr/share/licenses/$pkgname/"
+}
+
+package_gcc-ada() {
+  pkgdesc='Ada front-end for GCC (GNAT)'
+  depends=("gcc=$pkgver-$pkgrel")
+  provides=($pkgname-multilib)
+  replaces=($pkgname-multilib)
+  options+=(staticlibs)
+
+  cd gcc-build/gcc
+  make DESTDIR="$pkgdir" ada.install-{common,info}
+  install -m755 gnat1 "$pkgdir/${_libdir}"
+
+  cd "$srcdir"/gcc-build/$CHOST/libada
+  make DESTDIR="${pkgdir}" INSTALL="install" \
+    INSTALL_DATA="install -m644" install-libada
+
+  cd "$srcdir"/gcc-build/$CHOST/32/libada
+  make DESTDIR="${pkgdir}" INSTALL="install" \
+    INSTALL_DATA="install -m644" install-libada
+
+  ln -s gcc "$pkgdir/usr/bin/gnatgcc"
+
+  # insist on dynamic linking, but keep static libraries because gnatmake complains
+  mv "$pkgdir"/${_libdir}/adalib/libgna{rl,t}-${_majorver}.so "$pkgdir/usr/lib"
+  ln -s libgnarl-${_majorver}.so "$pkgdir/usr/lib/libgnarl.so"
+  ln -s libgnat-${_majorver}.so "$pkgdir/usr/lib/libgnat.so"
+  rm -f "$pkgdir"/${_libdir}/adalib/libgna{rl,t}.so
+
+  install -d "$pkgdir/usr/lib32/"
+  mv "$pkgdir"/${_libdir}/32/adalib/libgna{rl,t}-${_majorver}.so "$pkgdir/usr/lib32"
+  ln -s libgnarl-${_majorver}.so "$pkgdir/usr/lib32/libgnarl.so"
+  ln -s libgnat-${_majorver}.so "$pkgdir/usr/lib32/libgnat.so"
+  rm -f "$pkgdir"/${_libdir}/32/adalib/libgna{rl,t}.so
+
+  # Install Runtime Library Exception
+  install -d "$pkgdir/usr/share/licenses/$pkgname/"
+  ln -s /usr/share/licenses/gcc-libs/RUNTIME.LIBRARY.EXCEPTION \
+    "$pkgdir/usr/share/licenses/$pkgname/"
+}
+
+package_gcc-go() {
+  pkgdesc='Go front-end for GCC'
+  depends=("gcc=$pkgver-$pkgrel")
+  provides=("go=1.12.2" $pkgname-multilib)
+  replaces=($pkgname-multilib)
+  conflicts=(go)
+
+  cd gcc-build
+  make -C $CHOST/libgo DESTDIR="$pkgdir" install-exec-am
+  make -C $CHOST/32/libgo DESTDIR="$pkgdir" install-exec-am
+  make DESTDIR="$pkgdir" install-gotools
+  make -C gcc DESTDIR="$pkgdir" go.install-{common,man,info}
+
+  rm -f "$pkgdir"/usr/lib{,32}/libgo.so*
+  install -Dm755 gcc/go1 "$pkgdir/${_libdir}/go1"
+
+  # Install Runtime Library Exception
+  install -d "$pkgdir/usr/share/licenses/$pkgname/"
+  ln -s /usr/share/licenses/gcc-libs/RUNTIME.LIBRARY.EXCEPTION \
+    "$pkgdir/usr/share/licenses/$pkgname/"
+}
+
+package_lib32-gcc-libs() {
+  pkgdesc='32-bit runtime libraries shipped by GCC'
+  depends=('lib32-glibc>=2.27')
+  provides=(libgo.so libgfortran.so libubsan.so libasan.so)
+  groups=(multilib-devel)
+  options=(!emptydirs !strip)
+
+  cd gcc-build
+
+  make -C $CHOST/32/libgcc DESTDIR="$pkgdir" install-shared
+  rm -f "$pkgdir/$_libdir/32/libgcc_eh.a"
+
+  for lib in libatomic \
+             libgfortran \
+             libgo \
+             libgomp \
+             libitm \
+             libquadmath \
+             libsanitizer/{a,l,ub}san \
+             libstdc++-v3/src \
+             libvtv; do
+    make -C $CHOST/32/$lib DESTDIR="$pkgdir" install-toolexeclibLTLIBRARIES
+  done
+
+  make -C $CHOST/32/libobjc DESTDIR="$pkgdir" install-libs
+
+  make -C $CHOST/libphobos DESTDIR="$pkgdir" install
+  rm -f "$pkgdir"/usr/lib32/libgphobos.spec
+
+  # remove files provided by gcc-libs
+  rm -rf "$pkgdir"/usr/lib
+
+  # Install Runtime Library Exception
+  install -Dm644 "$srcdir/gcc/COPYING.RUNTIME" \
+    "$pkgdir/usr/share/licenses/lib32-gcc-libs/RUNTIME.LIBRARY.EXCEPTION"
+}
+
+package_gcc-d() {
+  pkgdesc="D frontend for GCC"
+  depends=("gcc=$pkgver-$pkgrel")
+  provides=(gdc)
+  replaces=(gdc)
+  options=('staticlibs')
+
+  cd gcc-build
+  make -C gcc DESTDIR="$pkgdir" d.install-{common,man,info}
+
+  install -Dm755 gcc/gdc "$pkgdir"/usr/bin/gdc
+  install -Dm755 gcc/d21 "$pkgdir"/"$_libdir"/d21
+
+  make -C $CHOST/libphobos DESTDIR="$pkgdir" install
+  rm -f "$pkgdir/usr/lib/"lib{gphobos,gdruntime}.so*
+  rm -f "$pkgdir/usr/lib32/"lib{gphobos,gdruntime}.so*
+
+  install -d "$pkgdir"/usr/include/dlang
+  ln -s /"${_libdir}"/include/d "$pkgdir"/usr/include/dlang/gdc
+
+  # Install Runtime Library Exception
+  install -d "$pkgdir/usr/share/licenses/$pkgname/"
+  ln -s /usr/share/licenses/gcc-libs/RUNTIME.LIBRARY.EXCEPTION \
+    "$pkgdir/usr/share/licenses/$pkgname/"
+}

Copied: gcc/repos/staging-x86_64/c89 (from rev 415305, gcc/trunk/c89)
===================================================================
--- staging-x86_64/c89	                        (rev 0)
+++ staging-x86_64/c89	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,10 @@
+#!/bin/sh
+fl="-std=c89"
+for opt; do
+  case "$opt" in
+    -ansi|-std=c89|-std=iso9899:1990) fl="";;
+    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
+	    exit 1;;
+  esac
+done
+exec gcc $fl ${1+"$@"}

Copied: gcc/repos/staging-x86_64/c99 (from rev 415305, gcc/trunk/c99)
===================================================================
--- staging-x86_64/c99	                        (rev 0)
+++ staging-x86_64/c99	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,10 @@
+#!/bin/sh
+fl="-std=c99"
+for opt; do
+  case "$opt" in
+    -std=c99|-std=iso9899:1999) fl="";;
+    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
+	    exit 1;;
+  esac
+done
+exec gcc $fl ${1+"$@"}

Copied: gcc/repos/staging-x86_64/fs64270.patch (from rev 415306, gcc/trunk/fs64270.patch)
===================================================================
--- staging-x86_64/fs64270.patch	                        (rev 0)
+++ staging-x86_64/fs64270.patch	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,26 @@
+Disable ssp on -nostdlib, -nodefaultlibs and -ffreestanding 
+
+--- a/gcc/gcc.c	2017-07-04 09:15:57.740793000 +0200
++++ b/gcc/gcc.c	2018-03-02 13:58:44.387741114 +0100
+@@ -857,6 +857,12 @@ proper position among the other output f
+ #define LINK_GCC_C_SEQUENCE_SPEC "%G %L %G"
+ #endif
+ 
++#ifdef ENABLE_DEFAULT_SSP
++#define NO_SSP_SPEC "%{nostdlib|nodefaultlibs|ffreestanding:-fno-stack-protector} "
++#else
++#define NO_SSP_SPEC ""
++#endif
++
+ #ifndef LINK_SSP_SPEC
+ #ifdef TARGET_LIBC_PROVIDES_SSP
+ #define LINK_SSP_SPEC "%{fstack-protector|fstack-protector-all" \
+@@ -1131,7 +1148,7 @@ static const char *cc1_options =
+  %{-version:--version}\
+  %{-help=*:--help=%*}\
+  %{!fsyntax-only:%{S:%W{o*}%{!o*:-o %b.s}}}\
+- %{fsyntax-only:-o %j} %{-param*}\
++ %{fsyntax-only:-o %j} %{-param*} " NO_SSP_SPEC "\
+  %{coverage:-fprofile-arcs -ftest-coverage}\
+  %{fprofile-arcs|fprofile-generate*|coverage:\
+    %{!fprofile-update=singel:\

Copied: gcc/repos/staging-x86_64/gcc-ada-repro.patch (from rev 415306, gcc/trunk/gcc-ada-repro.patch)
===================================================================
--- staging-x86_64/gcc-ada-repro.patch	                        (rev 0)
+++ staging-x86_64/gcc-ada-repro.patch	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,15 @@
+Avoid leaking current data on generated file for Ada.
+
+Index: gcc/ada/gcc-interface/Makefile.in
+===================================================================
+--- gcc/ada/gcc-interface/Makefile.in	(revision 268977)
++++ gcc/ada/gcc-interface/Makefile.in	(working copy)
+@@ -2407,6 +2407,7 @@ $(RTSDIR)/s-oscons.ads: ../stamp-gnatlib
+ 	    $(OSCONS_CPP) ; \
+ 	    $(OSCONS_EXTRACT) ; \
+ 	    ../bldtools/oscons/xoscons s-oscons)
++	touch -r $(fsrcpfx)ada/gsocket.h $@
+ 
+ gnatlib: ../stamp-gnatlib1-$(RTSDIR) ../stamp-gnatlib2-$(RTSDIR) $(RTSDIR)/s-oscons.ads
+ 	test -f $(RTSDIR)/s-oscons.ads || exit 1
+

Copied: gcc/repos/staging-x86_64/gcc11-Wno-format-security.patch (from rev 415307, gcc/trunk/gcc11-Wno-format-security.patch)
===================================================================
--- staging-x86_64/gcc11-Wno-format-security.patch	                        (rev 0)
+++ staging-x86_64/gcc11-Wno-format-security.patch	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,27 @@
+2017-02-25  Jakub Jelinek  <jakub at redhat.com>
+
+	* configure.ac: When adding -Wno-format, also add -Wno-format-security.
+	* configure: Regenerated.
+
+--- gcc/configure.ac.jj	2017-02-13 12:20:53.000000000 +0100
++++ gcc/configure.ac	2017-02-25 12:42:32.859175403 +0100
+@@ -480,7 +480,7 @@ AC_ARG_ENABLE(build-format-warnings,
+   AS_HELP_STRING([--disable-build-format-warnings],[don't use -Wformat while building GCC]),
+   [],[enable_build_format_warnings=yes])
+ AS_IF([test $enable_build_format_warnings = no],
+-      [wf_opt=-Wno-format],[wf_opt=])
++      [wf_opt="-Wno-format -Wno-format-security"],[wf_opt=])
+ ACX_PROG_CXX_WARNING_OPTS(
+ 	m4_quote(m4_do([-W -Wall -Wno-narrowing -Wwrite-strings ],
+ 		       [-Wcast-qual -Wno-error=format-diag $wf_opt])),
+--- gcc/configure.jj	2017-02-13 12:20:52.000000000 +0100
++++ gcc/configure	2017-02-25 12:42:50.041946391 +0100
+@@ -6647,7 +6647,7 @@ else
+ fi
+ 
+ if test $enable_build_format_warnings = no; then :
+-  wf_opt=-Wno-format
++  wf_opt="-Wno-format -Wno-format-security"
+ else
+   wf_opt=
+ fi

Copied: gcc/repos/staging-x86_64/gdc_phobos_path.patch (from rev 415307, gcc/trunk/gdc_phobos_path.patch)
===================================================================
--- staging-x86_64/gdc_phobos_path.patch	                        (rev 0)
+++ staging-x86_64/gdc_phobos_path.patch	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,14 @@
+diff -Naur a/gcc/d/d-incpath.cc b/gcc/d/d-incpath.cc
+--- a/gcc/d/d-incpath.cc	2019-01-01 13:31:55.000000000 +0100
++++ b/gcc/d/d-incpath.cc	2019-06-28 08:32:00.326241502 +0200
+@@ -140,7 +140,7 @@
+ 	    path = xstrdup (p->fname);
+ 
+ 	  /* Add D-specific suffix.  */
+-	  path = concat (path, "/d", NULL);
++	  path = concat (path, "/dlang/gdc", NULL);
+ 
+ 	  /* Ignore duplicate entries.  */
+ 	  bool found = false;
+
+ 

Copied: gcc/repos/staging-x86_64/ipa-fix-ICE-in-get_default_value.patch (from rev 415307, gcc/trunk/ipa-fix-ICE-in-get_default_value.patch)
===================================================================
--- staging-x86_64/ipa-fix-ICE-in-get_default_value.patch	                        (rev 0)
+++ staging-x86_64/ipa-fix-ICE-in-get_default_value.patch	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,80 @@
+From f91770216eade83f068528c1e4f00e2ac3b23044 Mon Sep 17 00:00:00 2001
+From: Martin Liska <mliska at suse.cz>
+Date: Thu, 13 Aug 2020 09:38:41 +0200
+Subject: [PATCH] ipa: fix ICE in get_default_value
+
+The patch aligns code with ipcp_bits_lattice::set_to_constant
+where we properly mask m_value with m_mask. The same should
+be done here.
+
+gcc/ChangeLog:
+
+	PR ipa/96482
+	* ipa-cp.c (ipcp_bits_lattice::meet_with_1): Mask m_value
+	with m_mask.
+
+gcc/testsuite/ChangeLog:
+
+	PR ipa/96482
+	* gcc.dg/ipa/pr96482-2.c: New test.
+---
+ gcc/ipa-cp.c                         |  2 +-
+ gcc/testsuite/gcc.dg/ipa/pr96482-2.c | 33 ++++++++++++++++++++++++++++
+ 2 files changed, 34 insertions(+), 1 deletion(-)
+ create mode 100644 gcc/testsuite/gcc.dg/ipa/pr96482-2.c
+
+diff --git a/gcc/ipa-cp.c b/gcc/ipa-cp.c
+index 2b21280d919..e4910a04ffa 100644
+--- a/gcc/ipa-cp.c
++++ b/gcc/ipa-cp.c
+@@ -1048,7 +1048,7 @@ ipcp_bits_lattice::meet_with_1 (widest_int value, widest_int mask,
+ 
+   widest_int old_mask = m_mask;
+   m_mask = (m_mask | mask) | (m_value ^ value);
+-  m_value &= value;
++  m_value &= ~m_mask;
+ 
+   if (wi::sext (m_mask, precision) == -1)
+     return set_to_bottom ();
+diff --git a/gcc/testsuite/gcc.dg/ipa/pr96482-2.c b/gcc/testsuite/gcc.dg/ipa/pr96482-2.c
+new file mode 100644
+index 00000000000..54b71ac4fc0
+--- /dev/null
++++ b/gcc/testsuite/gcc.dg/ipa/pr96482-2.c
+@@ -0,0 +1,33 @@
++/* PR ipa/96482 */
++/* { dg-do compile } */
++/* { dg-options "-O2"  } */
++
++int i2c_transfer();
++void _dev_err();
++
++struct i2c_msg {
++  char bufaddr;
++  int adapterdev;
++} wdt87xx_i2c_xfer_client;
++
++int wdt87xx_i2c_xfer_client_0, wdt87xx_i2c_xfer_rxdata, wdt87xx_get_string_str_idx;
++
++void
++static wdt87xx_i2c_xfer(void *txdata, unsigned rxlen) {
++  struct i2c_msg msgs[] = {wdt87xx_i2c_xfer_client_0, rxlen,
++                           wdt87xx_i2c_xfer_rxdata};
++  int error = i2c_transfer(wdt87xx_i2c_xfer_client, msgs);
++  _dev_err("", __func__, error);
++}
++static void wdt87xx_get_string(unsigned len) {
++  char tx_buf[] = {wdt87xx_get_string_str_idx, 3};
++  int rx_len = len + 2;
++  wdt87xx_i2c_xfer(tx_buf, rx_len);
++}
++
++void
++wdt87xx_ts_probe_tx_buf() {
++  wdt87xx_get_string(34);
++  wdt87xx_get_string(8);
++  wdt87xx_i2c_xfer(wdt87xx_ts_probe_tx_buf, 2);
++}
+-- 
+2.28.0
+

Copied: gcc/repos/staging-x86_64/ipa-fix-bit-CPP-when-combined-with-IPA-bit-CP.patch (from rev 415308, gcc/trunk/ipa-fix-bit-CPP-when-combined-with-IPA-bit-CP.patch)
===================================================================
--- staging-x86_64/ipa-fix-bit-CPP-when-combined-with-IPA-bit-CP.patch	                        (rev 0)
+++ staging-x86_64/ipa-fix-bit-CPP-when-combined-with-IPA-bit-CP.patch	2021-05-13 16:11:29 UTC (rev 415311)
@@ -0,0 +1,147 @@
+From d58f078ce2d53e5dab6b3d0d5f960504268e1894 Mon Sep 17 00:00:00 2001
+From: Martin Liska <mliska at suse.cz>
+Date: Wed, 12 Aug 2020 09:21:51 +0200
+Subject: [PATCH] ipa: fix bit CPP when combined with IPA bit CP
+
+As mentioned in the PR, let's consider the following example:
+
+int
+__attribute__((noinline))
+foo(int arg)
+{
+  if (arg == 3)
+    return 1;
+  if (arg == 4)
+    return 123;
+
+  __builtin_unreachable ();
+}
+
+during WPA we find all calls of the function
+(yes the call with value 5 is UBSAN):
+
+  Node: foo/0:
+    param [0]: 5 [loc_time: 4, loc_size: 2, prop_time: 0, prop_size: 0]
+               3 [loc_time: 3, loc_size: 3, prop_time: 0, prop_size: 0]
+         ctxs: VARIABLE
+         Bits: value = 0x5, mask = 0x6
+
+in LTRANS we have the following VRP info:
+
+  # RANGE [3, 3] NONZERO 3
+
+when we AND masks in get_default_value we end up with 6 & 3 = 2 (0x010).
+That means the only second (least significant bit) is unknown and
+value (5 = 0x101) & ~mask gives us either 7 (0x111) or 5 (0x101).
+
+That's why if (arg_2(D) == 3) gets optimized to false.
+
+gcc/ChangeLog:
+
+	PR ipa/96482
+	* ipa-cp.c (ipcp_bits_lattice::meet_with_1): Drop value bits
+	for bits that are unknown.
+	(ipcp_bits_lattice::set_to_constant): Likewise.
+	* tree-ssa-ccp.c (get_default_value): Add sanity check that
+	IPA CP bit info has all bits set to zero in bits that
+	are unknown.
+
+gcc/testsuite/ChangeLog:
+
+	PR ipa/96482
+	* gcc.dg/ipa/pr96482.c: New test.
+---
+ gcc/ipa-cp.c                       |  3 +-
+ gcc/testsuite/gcc.dg/ipa/pr96482.c | 44 ++++++++++++++++++++++++++++++
+ gcc/tree-ssa-ccp.c                 |  3 ++
+ 3 files changed, 49 insertions(+), 1 deletion(-)
+ create mode 100644 gcc/testsuite/gcc.dg/ipa/pr96482.c
+
+diff --git a/gcc/ipa-cp.c b/gcc/ipa-cp.c
+index 945a69977f3..2b21280d919 100644
+--- a/gcc/ipa-cp.c
++++ b/gcc/ipa-cp.c
+@@ -1011,7 +1011,7 @@ ipcp_bits_lattice::set_to_constant (widest_int value, widest_int mask)
+ {
+   gcc_assert (top_p ());
+   m_lattice_val = IPA_BITS_CONSTANT;
+-  m_value = value;
++  m_value = wi::bit_and (wi::bit_not (mask), value);
+   m_mask = mask;
+   return true;
+ }
+@@ -1048,6 +1048,7 @@ ipcp_bits_lattice::meet_with_1 (widest_int value, widest_int mask,
+ 
+   widest_int old_mask = m_mask;
+   m_mask = (m_mask | mask) | (m_value ^ value);
++  m_value &= value;
+ 
+   if (wi::sext (m_mask, precision) == -1)
+     return set_to_bottom ();
+diff --git a/gcc/testsuite/gcc.dg/ipa/pr96482.c b/gcc/testsuite/gcc.dg/ipa/pr96482.c
+new file mode 100644
+index 00000000000..68ead798d28
+--- /dev/null
++++ b/gcc/testsuite/gcc.dg/ipa/pr96482.c
+@@ -0,0 +1,44 @@
++/* PR ipa/96482 */
++/* { dg-do run } */
++/* { dg-options "-O2 -flto"  } */
++/* { dg-require-effective-target lto } */
++
++int
++__attribute__((noinline))
++foo(int arg)
++{
++  if (arg == 3)
++    return 1;
++  if (arg == 4)
++    return 123;
++
++  __builtin_unreachable ();
++}
++
++int
++__attribute__((noinline))
++baz(int x)
++{
++  if (x != 0)
++    return foo(3); /* called */
++
++  return 1;
++}
++
++int
++__attribute__((noinline))
++bar(int x)
++{
++  if (x == 0)
++    return foo(5); /* not executed */
++
++  return 1;
++}
++
++int main(int argc, char **argv)
++{
++  if (bar(argc) != baz(argc))
++    __builtin_abort ();
++
++  return 0;
++}
+diff --git a/gcc/tree-ssa-ccp.c b/gcc/tree-ssa-ccp.c
+index 7e3921869b8..65dffe06530 100644
+--- a/gcc/tree-ssa-ccp.c
++++ b/gcc/tree-ssa-ccp.c
+@@ -306,6 +306,9 @@ get_default_value (tree var)
+ 		{
+ 		  val.lattice_val = CONSTANT;
+ 		  val.value = value;
++		  widest_int ipa_value = wi::to_widest (value);
++		  /* Unknown bits from IPA CP must be equal to zero.  */
++		  gcc_assert (wi::bit_and (ipa_value, mask) == 0);
+ 		  val.mask = mask;
+ 		  if (nonzero_bits != -1)
+ 		    val.mask &= extend_mask (nonzero_bits,
+-- 
+2.28.0
+



More information about the arch-commits mailing list